#enemy.py
#Copyright (C) 2006 Evil Mr Henry
#This file is part of The Monster's Tower.

#The Monster's Tower is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.

#The Monster's Tower is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with The Monster's Tower; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import math, random

import g

class enemy_class:
    def __init__(self, loc, speed, rotspeed, sightrange, sightwidth):
        self.speed = speed
        self.rotspeed = rotspeed
        self.sightrange = sightrange
        self.sightwidth = sightwidth
        self.baseloc = loc
        self.loc = (loc[0]*10+5, loc[1]*10+5)
        self.movedir = 0
        self.sightdir = 1
        self.sightdirmove = 0

    def move(self, time, cur_level):
        xtmp = math.sin(self.movedir) * self.speed * time/ 4000.0
        ytmp = math.cos(self.movedir) * self.speed * time/ 4000.0
        if random.random() < 0.1:
            self.movedir = self.movedir + random.randrange(-50, 50, 5)*0.01
        self.loc, x, y = g.wallcheck(self.loc, xtmp, ytmp, cur_level)
        if x != xtmp or y != ytmp:
            self.movedir = self.movedir + random.randrange(-50, 50, 5)*0.03

        self.loc = (self.loc[0]+x, self.loc[1]+y)

        self.sightdirmove += random.randrange(-50, 50, 5)*0.0002
        if random.random() < 0.03:
            self.sightdirmove = random.randrange(-50, 50, 5)*0.0002
        if self.sightdirmove > 0.2: self.sightdirmove = 0.2
        if self.sightdirmove < -0.2: self.sightdirmove = -0.2
        self.sightdir = (self.sightdir+self.sightdirmove) % 6.28318530717958


class blood_class:
    def __init__(self, loc, livetime):
        self.loc = loc
        self.loc = (self.loc[0]+random.randrange(-50, 50, 5)*0.1,
        self.loc[1]+random.randrange(-50, 50, 5)*0.05)
        self.livetime = livetime * random.randrange(0, 500, 1)*0.002

blood_array = []