#g.py
#Copyright (C) 2006 Evil Mr Henry
#This file is part of The Monster's Tower.

#The Monster's Tower is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.

#The Monster's Tower is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with The Monster's Tower; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import level
import math

def wallcheck(location, x, y, cur_level):
    #print location, x, y
    #Prevent exiting through the sides of the level. This actually should
    #never happen.

    if location[0] + x < 0:
        x = 0
        location = (0, location[1])
    if location[1] + y < 0:
        y = 0
        location = (location[0], 0)
    if location[0] + x >= level.maps[cur_level].size[0]*10:
        x = 0
        location = (level.maps[cur_level].size[0]*10-1, location[1])
    if location[1] + y >= level.maps[cur_level].size[1]*10:
        y = 0
        location = (location[0], level.maps[cur_level].size[1]*10-1)

    #Make walls work...
    if level.maps[cur_level].grid[int(location[1]+y)/10][int(location[0]+x)/10] == '0':
        if level.maps[cur_level].grid[int(location[1])/10][int(location[0]+x)/10] == '0':
            x = 0
        if level.maps[cur_level].grid[int(location[1]+y)/10][int(location[0])/10] == '0':
            y = 0

    #No, you can't go through walls that meet diagonally...
    if level.maps[cur_level].grid[int(location[1])/10][int(location[0]+x)/10] == '0' and \
            level.maps[cur_level].grid[int(location[1]+y)/10][int(location[0])/10] == '0':
        x = y = 0
    return location, x, y

def kill(power, loc, cur_level):
    for i in range(len(level.maps[cur_level].enemy_list)-1, -1, -1):
        if dist(level.maps[cur_level].enemy_list[i].loc, loc, 4):
            if power == 1:
                for unused in range(15):
                    level.enemy.blood_array.append(level.enemy.blood_class(
                        level.maps[cur_level].enemy_list[i].loc, 10000))
            level.maps[cur_level].enemy_list.pop(i)
            return True
    return False

def dist(loc1, loc2, dist, actual=False):
    xtemp = loc2[0]-loc1[0]
    ytemp = loc2[1]-loc1[1]
    actdist = math.hypot(ytemp, xtemp)
    if actual:
        return abs(actdist), math.asin(ytemp/actdist)
    return abs(actdist) <= dist

